﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;

namespace WpfApp2
{
    public partial class MainWindow : Window
    {
        //Fileds:List für Quotte zu Speichern und ein index Variable,um aktuelle wett zu bestimmen
        private List<TextBox> quoteTextBoxes;
        private int index;

        public MainWindow()
        {
            //Constructor Method
            InitializeComponent();

            //Quote List zu intitialisieren
            quoteTextBoxes = new List<TextBox>();

            // radio button von Einzeln art Wett automatisch ausgewählt
            rkEinzeln.IsChecked = true;
            QuottePanel();
        }

        //Setup Method für Quote Panel
        private void QuottePanel()
        {
            index = 1;

            //löschen all angegebene quote 
            quottenPanel.Children.Clear();
            quoteTextBoxes.Clear();

            if (rkEinzeln.IsChecked == true)
            {
                QuotenInputErzeuger(index);

                //versteckt die AddQuote button ,wenn die einzeln button ist ausgewählt
                kpfAddQuotten.Visibility = Visibility.Collapsed;
            }
            else
            {
                QuotenInputErzeuger(index);

                //AddQuote button ist jetzt sichtbar ,um neu Quotte hinzufügen
                kpfAddQuotten.Visibility = Visibility.Visible;
            }

            //index wird actualiesiert
            index++;
        }

        //Method ,der dynamisch Stackpanel erzeugt
        private void QuotenInputErzeuger(int index)
        {

            //ein Stackpanel zu herstellen
            StackPanel rowPanel = new StackPanel();
            rowPanel.Orientation = Orientation.Horizontal;

            //ein Label zu herstellen
            Label label = new Label();
            label.Content = "Quoten der " + index + "-x Wette:";
            label.Width = 150;

            //ein neu TextBox zu erzeugen ,um quote zu geben
            TextBox textBox = new TextBox();
            textBox.Width = 100;
            textBox.Height = 25;

            //Label und textbox zu Stackpanel zu addieren
            rowPanel.Children.Add(label);
            rowPanel.Children.Add(textBox);

            //die neu Stackpanel zu der MainWindow.xaml Stackpanel zu addieren
            quottenPanel.Children.Add(rowPanel);
            quoteTextBoxes.Add(textBox);
        }

        //Ereignis Hanldler | Das Ereignis: Wett Art radio button auswählen
        private void WettArtRadioAusgewählt(object sender, RoutedEventArgs e)
        {
            //Setup Quotte Methode zu rufen
            QuottePanel();
        }

        //Ereignis Handler | Das Ereignis: Add Quotte KNopf drücken
        private void kpfAddQuottenGedrückt(object sender, RoutedEventArgs e)
        {
            //Neu Stackpanel zu erzeugen
                QuotenInputErzeuger(index);
            
        }

        //Ereignis Handler | Das Ereignis: Berechnen Knopf drücken
        private void kpfBerechnenGedrückt(object sender, RoutedEventArgs e)
        {

            //zeigt ein Nachricht wenn nichts wird angegeben
            if (string.IsNullOrWhiteSpace(txtBetrag.Text))
            {
                MessageBox.Show("Bitte geben Sie den Wetteinsatz ein.", "Fehler");
                return;
            }

            //zeigt ein Nachricht wenn nichts wird angegeben
            if (string.IsNullOrWhiteSpace(txtGewinnWahrscheinlichkeit.Text))
            {
                MessageBox.Show("Bitte geben Sie Ihre geschätzte Gewinnwahrscheinlichkeit ein (Wert zwischen 0 und 1).", "Fehler");
                return;
            }

            //Convertiert input von string zu decimal input
            decimal probability = Convert.ToDecimal(txtGewinnWahrscheinlichkeit.Text);

            //zeigt ein Nachricht wenn die gewinnwharscheinlichkeit ist größe als 1 oder kleiner als 0
            if (probability < 0 || probability > 1)
            {
                MessageBox.Show("Wahrscheinlichkeit muss zwischen 0 und 1 sein!");
                return;
            }

            //Convertiert Betrag input von string zu decimal input
            decimal betrag = Convert.ToDecimal(txtBetrag.Text);

            //Variable für die Summe der Quotten (einzeln=1  ||  Kombi=quotte1*quotte2*...00*
            decimal summe = 1.0m;

            //Der Anzahl der Alle Wettw
            int anzahlWetten = 0;

            for (int i = 0; i < quoteTextBoxes.Count; i++)
            {

                //Variable ,der jeder Quotte speichert
                TextBox oddBox = quoteTextBoxes[i];

                //Bedigung:es muss am meindestens eine Quotte wird angegeben
                if (!string.IsNullOrWhiteSpace(oddBox.Text))
                {
                    //Cobvertiert Quotte von string zu decimal
                    decimal quote = Convert.ToDecimal(oddBox.Text);
                    summe = summe * quote;

                    //Anzahl der Wetten wird aktualiesiert
                    anzahlWetten++;
                }
            }

            if (anzahlWetten == 0)
            {
                MessageBox.Show("Bitte geben Sie mindestens eine Quote ein.", "Fehler");
                return;
            }

            decimal gewinnWahrscheinlichkeit = probability;
            decimal verlustWahrscheinlichkeit = 1 - gewinnWahrscheinlichkeit;
            decimal potenziellerGewinn = betrag * (summe - 1);
            decimal ev = (potenziellerGewinn * gewinnWahrscheinlichkeit) - (betrag * verlustWahrscheinlichkeit);

            //Gibt ZeigErgebnis Method Argumments
            ZeigeErgebnis(ev, betrag, summe, anzahlWetten, gewinnWahrscheinlichkeit);
        }


        //Zeigt die Wettart, Betrag, Gesamtquote, Wahrscheinlichkeiten, potenzieller Gewinn und Erwartungswert
        private void ZeigeErgebnis(decimal ev, decimal betrag, decimal summe, int anzahlWetten, decimal probability)
        {
            ergebnisPanel.Children.Clear();

            //Stackpanel für info erzeugen
            StackPanel infoPanel = new StackPanel();

            string wettart;
            //Speicher der Art der Wett zu wettart variable
            if (rkEinzeln.IsChecked == true)
            {
                wettart = "Einzeln";
            }
            else
            {
                wettart = anzahlWetten + "x Kombi";
            }

            //TextBlock zeigt die Wettart
            TextBlock wettartBlock = new TextBlock();
            wettartBlock.Text = "Wettart: " + wettart;
            infoPanel.Children.Add(wettartBlock);

            //Convertiert Berechnungen zu Prozent
            decimal probabilityProzent = probability * 100;
            decimal quoteWhascheinlichkeit = (1 / summe) * 100;
            decimal gewinn = betrag * (summe - 1);

            //Ein TextBlock für Info erzeugen
            TextBlock infoBlock = new TextBlock();

            infoBlock.Text = "*******************INFO*******************\n";
            infoBlock.Text += "Betrag = " + betrag + "\n";
            infoBlock.Text += "Summe der Quoten = " + summe + "\n";
            infoBlock.Text += "Ihre geschätzte Gewinnwahrscheinlichkeit = " + Math.Round(probabilityProzent, 2) + "\n";
            infoBlock.Text += "Implizite Wahrscheinlichkeit (1/Quote) = " + Math.Round(quoteWhascheinlichkeit, 2) + "\n";
            infoBlock.Text += "Potenzieller Gewinn = " + Math.Round(gewinn, 2) + "€" + "\n";
            infoBlock.Text += "*******************INFO*******************";

            //Addiere Textblock der Info zu stack panel
            infoPanel.Children.Add(infoBlock);

            //Addiere Stackpanel zu stackpanel,der in MainWindow.xaml steht.
            ergebnisPanel.Children.Add(infoPanel);

            //Stackpanel für ev und bewertung zu erzeugen
            StackPanel evPanel = new StackPanel();

            //TextBlock für ev erzeugen
            TextBlock evWertBlock = new TextBlock();
            evWertBlock.Text = "Der Erwartungswert ist: " + ev ;
            evWertBlock.FontWeight = FontWeights.Bold;

            //Addiere Textblock der eb zu stackpanel
            evPanel.Children.Add(evWertBlock);

            //Textblock für Bewertung erzeugen
            TextBlock evBewertung = new TextBlock();
            if (ev < 0)
            {
                evBewertung.Text = "Negative EV - Diese Wette ist mathematisch nicht profitabel.";
            }
            else if (ev > 0)
            {
                evBewertung.Text = "Positive EV - Diese Wette hat einen mathematischen Vorteil!";
            }
            else
            {
                evBewertung.Text = "EV ist Null - Diese Wette ist fair.";
            }

            //Textblock der Bewertung zu Stackpanel addieren
            evPanel.Children.Add(evBewertung);

            //Stackpanel der ev und bewertung zu Stackpanel ,der in MainWindow.xaml steht.
            ergebnisPanel.Children.Add(evPanel);
        }
    }
}